 import java.util.*;
 import java.io.*;
 
 public abstract class Personne implements Serializable {
 
 	public static HashSet population= new HashSet(); // ensemble des personnes qui ont t cres
	
 	protected String nom, prenom;
	protected Date date_naissance, date_deces;
	protected boolean sexe; //true indique qu'il s'agit d'un homme
	protected Adulte pere, mere;

	public String getNom() {return nom;}
	public String getPrenom() {return prenom;}
	public Date getNaissance() {return date_naissance;}
	public Date getDeces() {return date_deces;}
	public boolean getSexe() {return sexe;}
	public Personne getPere() {return pere;}
	public Personne getMere() {return mere;}
				
 	public Personne(boolean sexe, Date naissance, String prenom){ //Constructeur par dfaut : intitialise les proprits avec des vbaleurs par dfaut
		this.sexe=sexe;
		this.date_naissance=naissance;
		this.prenom=prenom;
		nom="";
		date_deces=null;
		pere=null;
		mere=null;
		population.add(this);
	}	
	
	protected void problemeCreation(String messageErreur, Personne p) {
 		population.remove(this);
		throw new BiologiqueException(messageErreur, p);}
	

	public void mourir(Date deces) {
		if (deces.compareTo(date_naissance)<0) throw new PersonneException ("On ne peut pas mourir avant d'etre n",this);
		else date_deces=deces;}
	
 	public String  toString() {
		String s=prenom+" "+nom;
		if (sexe)
			s=s+" (M)";
		else  s=s+" (F)";
		if (date_naissance!=null) s=s+" n le "+date_naissance;
		return s;}

	public boolean fratrie(Personne p) {
	return (pere!=null && pere==p.pere && mere!=null && mere==p.mere);}

	public boolean demiFratrie(Personne p) {
	return ((pere!=null && pere==p.pere) || (mere!=null && mere==p.mere));}

	public boolean oncleOuTante(Personne p) {
		return ((pere!=null && pere.fratrie(p)) || (mere!=null && mere.fratrie(p)));
	}
		
	public boolean ancetre(Personne p) {
	if (p==null) return false;
	else if (pere==p || mere==p) return true;
		else if (pere!=null && pere.ancetre(p)) return true;
			else if (mere!=null && mere.ancetre(p)) return true;
				else return false;
	}

	public void arbreGenealogique(int indentation){
		for (int i=0;i<indentation-1;i++) System.out.print("  ");
		System.out.println(toString());	
		if (pere!=null) pere.arbreGenealogique(indentation+1);
		if (mere!=null) mere.arbreGenealogique(indentation+1);
	}
	
	/** Retourne la premire personne trouve dans la population avec ce nom et ce prnom*/
	public static Personne rechercherPersonne(String nom, String prenom) {
		Iterator i=Personne.population.iterator();
		Personne p=null;
		boolean trouve=false;
		while (i.hasNext() && !trouve) {
			p=(Personne)(i.next());
			trouve=(nom.equals(p.getNom()) && prenom.equals(p.getPrenom()));
		}
		if (trouve) return p;
		else return null;}
		
	/** Permet la saisie au clavier d'une personne */
	public static Personne saisirPersonne() {
		String prenom=Keyboard.readString("Entrer son prnom :");	
		int jour=Keyboard.readInt("Entrer le jour de naissance:",1,31);
		int mois=Keyboard.readInt("Entrer le mois de naissance:",1,12);
		int annee=Keyboard.readInt("Entrer l'annee de naissance:");
		Date naissance=null;
		do try {
		GregorianCalendar c=new GregorianCalendar();
		c.set(annee, mois-1, jour);
		naissance=c.getTime();}
		catch (Exception e)
			{System.out.println("Date incorrecte:"+e.toString());
			 naissance=null;}
		while (naissance==null);	 
		boolean sexe=(Keyboard.readChar("Est-ce un homme (H) ou une femme (F):")=='H');
		Personne pere;
		Personne mere;
		Personne p;
		do {mere=Personne.rechercherPersonne(Keyboard.readString("Entrer le nom de sa mere :"),Keyboard.readString("Entrer son prnom de sa mre:"));
			if ((mere!=null) && !(mere instanceof Adulte)) System.out.println("Dsol, ce n'est pas un adulte; elle le peut pas avoir d'enfants");
		      }
		while (!(mere==null || mere instanceof Adulte));
		if (mere==null) {
			System.out.println("Cette personne n'aura pas de parents.");
			String nom=Keyboard.readString("Entrer son nom :");
			p = new Bebe(sexe,naissance,prenom,nom);}
		else {do {pere=Personne.rechercherPersonne(Keyboard.readString("Entrer le nom de son pere :"),Keyboard.readString("Entrer son prnom de son pre:"));
				if ((pere!=null) && !(pere instanceof Adulte)) System.out.println("Dsol, ce n'est pas un adulte; il le peut pas avoir d'enfants");
			      }
			while (!(pere==null || pere instanceof Adulte));
			if (pere==null) p = new Bebe(sexe,(Adulte)mere,naissance,prenom);
			else p = new Bebe(sexe,(Adulte)pere,(Adulte)mere,naissance,prenom);}
		char choix =Keyboard.readChar("Est-ce un bb (B), un enfant(E) ou un adulte(A):");
		if (choix=='E') {
			String ecole=Keyboard.readString("Dans quelle cole est-il scolaris :");
			String classe=Keyboard.readString("Dans quelle classe est-il :");
			p= new Enfant((Bebe)p,classe,ecole);}
		else 	if (choix=='A') {String profession=Keyboard.readString("Quelle est sa profession :");
			p= new Adulte(new Enfant((Bebe)p,"",""),profession);}
	return p;}	


	public static void main(String args[]) {
	}
}